## ros-melodic-rviz-visual-tools 3.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6)
project(rviz_visual_tools)

if(NOT MSVC)
  add_compile_options(-std=c++11)
  # Warnings
  add_definitions(-W -Wall -Wextra
    #-Wcast-qual
    -Wwrite-strings -Wunreachable-code -Wpointer-arith
    -Winit-self -Wredundant-decls
    -Wno-unused-parameter -Wno-unused-function)
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

find_package(catkin REQUIRED COMPONENTS
  eigen_conversions
  eigen_stl_containers
  geometry_msgs
  graph_msgs
  roscpp
  roslint
  rostest
  rviz
  sensor_msgs
  std_msgs
  tf_conversions
  trajectory_msgs
  visualization_msgs
)

find_package(Eigen3 REQUIRED)
find_package(Boost REQUIRED thread system)
find_package(PkgConfig REQUIRED)
pkg_check_modules(OGRE_OV OGRE)

# Qt 4 or 5
if("${rviz_QT_VERSION}" VERSION_LESS "5")
  find_package(Qt4 ${rviz_QT_VERSION} REQUIRED QtCore QtGui)
  include(${QT_USE_FILE})
  macro(qt_wrap_ui)
    qt4_wrap_ui(${ARGN})
  endmacro()
else()
  find_package(Qt5 ${rviz_QT_VERSION} REQUIRED Core Widgets)
  set(QT_LIBRARIES Qt5::Widgets)
  macro(qt_wrap_ui)
    qt5_wrap_ui(${ARGN})
  endmacro()
endif()
## Prefer the Qt signals and slots to avoid defining "emit", "slots",
## etc because they can conflict with boost signals, so define QT_NO_KEYWORDS here.
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOMOC_COMPILER_PREDEFINES OFF)
add_definitions(-DQT_NO_KEYWORDS)

catkin_package(
  LIBRARIES
    ${PROJECT_NAME}
    ${PROJECT_NAME}_gui
    ${PROJECT_NAME}_remote_control
    ${PROJECT_NAME}_imarker_simple
  CATKIN_DEPENDS
    eigen_conversions
    geometry_msgs
    graph_msgs
    roscpp
    sensor_msgs
    std_msgs
    tf_conversions
    trajectory_msgs
    visualization_msgs
  INCLUDE_DIRS
    include
    ${OGRE_OV_INCLUDE_DIRS}
)

include_directories(SYSTEM include ${catkin_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIRS} ${OGRE_OV_INCLUDE_DIRS})

###########
## Build ##
###########

set(SOURCE_FILES
  src/${PROJECT_NAME}_gui.cpp
  src/key_tool.cpp
)

# Rviz GUI library
add_library(${PROJECT_NAME}_gui ${SOURCE_FILES} src/remote_control.cpp)
target_link_libraries(${PROJECT_NAME}_gui ${rviz_DEFAULT_PLUGIN_LIBRARIES} ${QT_LIBRARIES} ${catkin_LIBRARIES})

# Remote control library
add_library(${PROJECT_NAME}_remote_control src/remote_control.cpp)
target_link_libraries(${PROJECT_NAME}_remote_control ${catkin_LIBRARIES})

# Visualization Tools Library
add_library(${PROJECT_NAME}
  src/${PROJECT_NAME}.cpp
  src/tf_visual_tools.cpp
)
target_link_libraries(${PROJECT_NAME}
  ${PROJECT_NAME}_remote_control
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

# Library
add_library(${PROJECT_NAME}_imarker_simple
  src/imarker_simple.cpp
)
target_link_libraries(${PROJECT_NAME}_imarker_simple
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  ${PROJECT_NAME}
)

# Demo executable
add_executable(${PROJECT_NAME}_demo src/${PROJECT_NAME}_demo.cpp)
target_link_libraries(${PROJECT_NAME}_demo
  ${catkin_LIBRARIES} ${PROJECT_NAME}
)
set_target_properties(${PROJECT_NAME}_demo
  PROPERTIES
  OUTPUT_NAME
  demo PREFIX ""
)

# Demo executable
add_executable(${PROJECT_NAME}_imarker_simple_demo src/imarker_simple_demo.cpp)
target_link_libraries(${PROJECT_NAME}_imarker_simple_demo
  ${catkin_LIBRARIES} ${PROJECT_NAME} ${PROJECT_NAME}_imarker_simple
)
set_target_properties(${PROJECT_NAME}_imarker_simple_demo
  PROPERTIES
  OUTPUT_NAME
  imarker_simple_demo PREFIX ""
)

##########
## TEST ##
##########

if(CATKIN_ENABLE_TESTING)

  add_rostest_gtest(rvt_test launch/rvt_test.launch tests/rvt_test.cpp)
  target_link_libraries(rvt_test
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${Boost_LIBRARIES}
  )

endif()

## Test for correct C++ source code
roslint_cpp()

#############
## Install ##
#############

# Install libraries
install(
  TARGETS
    ${PROJECT_NAME}
    ${PROJECT_NAME}_gui
    ${PROJECT_NAME}_imarker_simple
    ${PROJECT_NAME}_remote_control
  LIBRARY DESTINATION
    ${CATKIN_PACKAGE_LIB_DESTINATION}
  ARCHIVE DESTINATION
    ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION
    ${CATKIN_GLOBAL_BIN_DESTINATION}
)

# Install header files
install(DIRECTORY include/${PROJECT_NAME}/   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

# Install shared resources
install(DIRECTORY launch    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})
install(DIRECTORY resources DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

# Install xml plugin config
install(FILES
  plugin_description.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

# Install executables
install(TARGETS ${PROJECT_NAME}_demo ${PROJECT_NAME}_imarker_simple_demo
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-melodic-rviz-visual-tools (3.8.0-4stretch) stretch; urgency=high

  * Windows bring up. (#116 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/116>)
  * Change email address (#114 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/114>)
  * Fixed publishCylinder namespace (#109 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/109>)
  * Remove default arguments to make function calls not ambiguous (#112 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/112>)
    * Remove default arguments to make function calls not ambiguous
    * Remove further default values
    * Add unit tests for publishPath() functions, make sucess return value more stringent
  * Initizalize quaternions in demo to avoid warning (#111 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/111>)
  * Fix node type in demo launch files (#110 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/110>)
  * Only auto-assign one reviewer (#107 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/107>)
  * Use LOGNAME for logging re:moveit styel (#106 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/106>)
  * Document Github Probot for Auto Assign (#101 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/101>)
  * Contributors: Dave Coleman, Sean Yen, Victor Lamoine, d-walsh

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 17 Sep 2019 21:00:00 -0000

ros-melodic-rviz-visual-tools (3.7.0-4stretch) stretch; urgency=high

  * Fix Eigen::Affine3d for Melodic (using Eigen::Isometry3d) (#105 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/105>)
  * Improve documentation (#100 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/100>)
  * Fix some catkin_lint warnings and rename targets output (#98 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/98>)
  * Update README Kinetic to Melodic (#102 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/102>)
  * Add Melodic build farm badges (#99 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/99>)
  * Add ccache support (#93 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/93>)
  * no ros::spinOnce() (#82 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/82>)
  * Deprecate old functions for ROS Melodic (#91 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/91>)
  * Improve package with catkin_lint (#89 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/89>)
  * Add OGRE dependency (#88 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/88>)
  * Automoc requires at least cmake version 2.8.6 (#86 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/86>)
  * Fix Travis badge (#84 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/84>)
  * The code already uses AUTOMOC (#76 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/76>)
  * Contributors: Dave Coleman, Jochen Sprickerhof, Michael Görner, Simon Schmeisser, Victor Lamoine

 -- Dave Coleman <davetcoleman@gmail.com>  Sun, 25 Nov 2018 21:00:00 -0000

ros-melodic-rviz-visual-tools (3.6.1-4stretch) stretch; urgency=high

  * Actually link qt code into the gui library (#74 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/74>)
  * Contributors: Michael Goerner

 -- Dave Coleman <davetcoleman@gmail.com>  Wed, 30 May 2018 21:00:00 -0000

ros-melodic-rviz-visual-tools (3.6.0-4stretch) stretch; urgency=high

  * Addresses Issue #49 - Default Constructor Not Nodelet Friendly
  * Added option to pass in a node handle in the constructor that defaults to
  * Reset marker should publish initialized quaternion
  * Improve code quality - add const, static, C++11 features, clang-format
  * Create demo executable for IMarkerSimple
  * Improve memory efficiency of functions
  * Contributors: Dave Coleman, Geoffrey Chiou, Victor Lamoine

 -- Dave Coleman <davetcoleman@gmail.com>  Sun, 14 Jan 2018 21:00:00 -0000

ros-melodic-rviz-visual-tools (3.5.1-4stretch) stretch; urgency=high

  * Normalize quaternion before storage
  * Fix for ambiguous function call to publishAxis
  * Add linking to visualization tools library for imarker_simple
  * Added arrow pub to take two points
  * Document clang-tidy
  * catkin lint
  * roslint applied
  * Clang-format again
  * Clang-tidy ALL
  * C++11 optimizations
  * Fix deprecated calls to convertFromXYZRPY
  * Add new convertPoseSafe() function
  * New convertFromXYZRPY() function to avoid deprecation warning
  * Allow to enable frame locking in the markers/markers arrays
  * Update license year
  * IMarkerSimple: set name and pose
  * New printTransformFull() function
  * Removed deprecated warning
  * New class for easily using 6dof imarkers
  * More options to tf_visual_tools
  * Update README.md
  * Contributors: Andy McEvoy, Dave Coleman, Fadri Furrer, Victor Lamoine

 -- Dave Coleman <davetcoleman@gmail.com>  Sun, 24 Dec 2017 21:00:00 -0000

ros-melodic-rviz-visual-tools (3.4.1-4stretch) stretch; urgency=high

  * Add dependency on QT5 for Ubuntu Zesty/Lunar support
  * Allow publishPath with std_msgs::ColorRGBA
  * Make INFO msg DEBUG
  * Contributors: Dave Coleman, Victor Lamoine

 -- Dave Coleman <davetcoleman@gmail.com>  Mon, 19 Jun 2017 21:00:00 -0000

ros-melodic-rviz-visual-tools (3.4.0-4stretch) stretch; urgency=high

  * Consolidated publishing into RemoteReciever class
  * Improve console output
  * Add RvizGui and KeyTool
  * Enable remote control from withing rviz_visual_tools
  * New publishPath() function
  * Shorten number of lines printTranslation() requires
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 01 Nov 2016 21:00:00 -0000

ros-melodic-rviz-visual-tools (3.3.0-4stretch) stretch; urgency=high

  * BREAKING CHANGE: Make batch publishing enabled by default
  * Removed enableInternalBatchPublishing()
  * Removed triggerInternalBatchPublishAndDisable()
  * Deprecated triggerBatchPublish() in favor of function name trigger()


=== debian/control ===
Source: ros-melodic-rviz-visual-tools
Section: misc
Priority: extra
Maintainer: Dave Coleman <davetcoleman@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libogre-1.9-dev, libqt5x11extras5-dev, ros-melodic-catkin, ros-melodic-eigen-conversions, ros-melodic-eigen-stl-containers, ros-melodic-geometry-msgs, ros-melodic-graph-msgs, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf-conversions, ros-melodic-trajectory-msgs, ros-melodic-visualization-msgs
Homepage: https://github.com/davetcoleman/rviz_visual_tools
Standards-Version: 3.9.2

Package: ros-melodic-rviz-visual-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libogre-1.9-dev, libqt5x11extras5-dev, ros-melodic-eigen-conversions, ros-melodic-eigen-stl-containers, ros-melodic-geometry-msgs, ros-melodic-graph-msgs, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf-conversions, ros-melodic-trajectory-msgs, ros-melodic-visualization-msgs
Description: Utility functions for displaying and debugging data in Rviz via published markers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-rviz-visual-tools//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
